/***********************************************************************
 *      ΥץץϰʲνҤȴǤ             *
 *                                                                     *
 *          X Window OSF/Motif ġ륭å ץߥ (II)        *
 *            - եåȼ꥽ܸ졦̿ -             *
 *                                                                     *
 *      Copyright 1995,                                          *
 *                                                                     *
 *      ɽȤս񤭤ޤޤƤ¤ꡢ                   *
 *      ΥץץۤƤޤޤ                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

extern Boolean CvtStrToBitmap(); /* ꥽С */

static GC gc; /* եåƥ (Xlib ɬ) */

typedef struct {  /* (1) ꥽ͳǼ¤Τ */
    Pixmap bitmap;      /* ԥåޥå */
} CustomRec, *CustomPtr;

static XtResource res[] = {  /* (2) ȼ꥽ */
  {"bitmap", "Bitmap", XtRBitmap, sizeof(Pixmap), XtOffsetOf(CustomRec, bitmap),
   XtRImmediate, (XtPointer) XtUnspecifiedPixmap},
};

static XrmOptionDescRec opt[] = { /* (3) ȼץ */
  {"-bm", "*canvas.bitmap", XrmoptionSepArg, NULL},
};

/* (4) ɥꥢϪФޤϥꥵȡԥåޥåפɽ */
static void RedrawCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Pixmap bitmap = (Pixmap)client_data;
    XmDrawingAreaCallbackStruct *cb = (XmDrawingAreaCallbackStruct *)call_data;
    Window r;
    int x, y;
    unsigned int pw, ph, bw, d;
    Dimension dw, dh;

    if (bitmap == XtUnspecifiedPixmap)
        return;
    /* ԥåޥåפΥĴ٤ */
    if (XGetGeometry(XtDisplay(w), bitmap, &r, &x, &y, &pw, &ph, &bw, &d) == 0)
        return;

    /* ɥꥢΥѤȡä󥦥ɥ򥯥ꥢ */
    if (cb->reason == XmCR_RESIZE)
        XClearWindow(XtDisplay(w), cb->window);

    /* ɥꥢΥĴ٤ */
    XtVaGetValues(w, XmNwidth,  &dw, XmNheight, &dh, NULL);

    /* ɥꥢ˥ԥåޥåפɽ */
    XCopyArea(XtDisplay(w), bitmap, cb->window, gc, 0, 0, pw, ph,
              (dw - pw) / 2, (dh - ph) / 2);
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, canvas;
    Arg    al[20];
    int    ac;
    CustomRec data;  /* ꥽ͳǼ¤ */
    XtConvertArgRec args[2];  /* ꥽СϤǡ */
    Screen *screen;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;       /* ꥽ǡ١ */
    toplevel = XtAppInitialize(&app_context, "Bitmapres", opt, XtNumber(opt),
                               &argc, argv, NULL, al, ac);

    /* (5) ꥽СϤǡ */
    screen = XtScreen(toplevel);
    args[0].address_mode = XtAddress;
    args[0].address_id = (XtPointer)&screen;
    args[0].size = sizeof(Screen *);
    args[1].address_mode = XtAddress;
    args[1].address_id = (XtPointer)&canvas;
    args[1].size = sizeof(Widget);

    /* (6) ӥåȥޥåסե̾ Pixmap ؤΥ꥽СϿ */
    XtAppSetTypeConverter(app_context, XtRString, XtRBitmap, CvtStrToBitmap,
                          args, XtNumber(args), XtCacheByDisplay, NULL);

    ac = 0;
    panel = XmCreateForm(toplevel, "panel", al, ac);
    XtManageChild(panel);

    ac = 0;
    canvas = XmCreateDrawingArea(panel, "canvas", al, ac);
    XtManageChild(canvas);

    /* (7) ȼ꥽ͤμФ (꥽СƤӽФ) */
    XtGetApplicationResources(canvas, &data, res, XtNumber(res), NULL, 0);
            /* 줿ԥåޥåפ data.bitmap ˳Ǽ */
    XtAddCallback(canvas, XmNexposeCallback, RedrawCB, data.bitmap);
    XtAddCallback(canvas, XmNresizeCallback, RedrawCB, data.bitmap);

    XtRealizeWidget(toplevel);
    gc = XCreateGC(XtDisplay(canvas), XtWindow(canvas), NULL, NULL);
    XtAppMainLoop(app_context);
}
