/***********************************************************************
 *      ΥץץϰʲνҤȴǤ             *
 *                                                                     *
 *          X Window OSF/Motif ġ륭å ץߥ (II)        *
 *            - եåȼ꥽ܸ졦̿ -             *
 *                                                                     *
 *      Copyright 1995,                                          *
 *                                                                     *
 *      ɽȤս񤭤ޤޤƤ¤ꡢ                   *
 *      ΥץץۤƤޤޤ                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void CopyCB();
static void PasteCB();
static Boolean ConvertProc();
static void LoseProc();
static void GetValueProc();

static Widget box, figure, title;
static Boolean owner = False;
static Atom xa_figure, xa_title;
static Pixmap pixmap;

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, copy, paste;
    Arg al[20];
    int ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtOpenApplication(&app_context, "Select2type", NULL, 0,
                     &argc, argv, NULL, sessionShellWidgetClass, al, ac);

    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* ȥ٥ϤȢ */
    ac = 0;
    box = XmCreateRowColumn(panel, "box", al, ac);
    XtManageChild(box);
    /*  */
    ac = 0;
    figure = XmCreateLabel(box, "figure", al, ac);
    XtManageChild(figure);
    /* ٥ */
    ac = 0;
    title = XmCreateLabel(box, "title", al, ac);
    XtManageChild(title);

    /* [ԡ] ܥ --> ͭ: 쥯ͭ */
    ac = 0;
    copy = XmCreatePushButton(panel, "copy", al, ac);
    XtAddCallback(copy, XmNactivateCallback, CopyCB, NULL);
    XtManageChild(copy);

    /* [ڡ] ܥ --> ׵: 쥯󡦥ǡ׵ */
    ac = 0;
    paste = XmCreatePushButton(panel, "paste", al, ac);
    XtAddCallback(paste, XmNactivateCallback, PasteCB, NULL);
    XtManageChild(paste);

    /* "_FIGURE"  "_TITLE" ΥȥƤ */
    xa_figure = XmInternAtom(XtDisplay(toplevel), "_FIGURE", False);
    xa_title = XmInternAtom(XtDisplay(toplevel), "_TITLE", False);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

/* ͭ: [ԡ] ܥΥХå */
static void CopyCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Pixel fg, bg;

    if (owner)    /* Ǥ˼ʬͭԤˤʤäƤС⤷ʤ */
        return;

    /* 쥯ͭ (3ĤΥХåϿ) */
    if (XtOwnSelection(box, XA_PRIMARY,
                       XtLastTimestampProcessed(XtDisplay(box)),
                       ConvertProc, LoseProc, NULL)) {
        /* ͭǤ顤ȥ٥ȿžɽΤ餻 */
        XtVaGetValues(figure, XmNforeground, &fg, XmNbackground, &bg, NULL);
        XtVaSetValues(figure, XmNforeground, bg, XmNbackground, fg, NULL);
        XtVaGetValues(title, XmNforeground, &fg, XmNbackground, &bg, NULL);
        XtVaSetValues(title, XmNforeground, bg, XmNbackground, fg, NULL);
        owner = True;
    }
}

/* ͭ: 쥯νͭ򼺤äȤ˸ƤӽФ */
static void LoseProc(w, selection)
    Widget w;
    Atom *selection;
{
    Pixel fg, bg;

    /* 쥯νͭԤǤʤʤä顤Ĵɽ */
    if (*selection == XA_PRIMARY) {
        XtVaGetValues(figure, XmNforeground, &fg, XmNbackground, &bg, NULL);
        XtVaSetValues(figure, XmNforeground, bg, XmNbackground, fg, NULL);
        XtVaGetValues(title, XmNforeground, &fg, XmNbackground, &bg, NULL);
        XtVaSetValues(title, XmNforeground, bg, XmNbackground, fg, NULL);
        owner = False;
    }
}

/* ׵: [ڡ] ܥΥХå */
static void PasteCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    /* (1) ׵ (MULTIPLE) γ */
    XtCreateSelectionRequest(box, XA_PRIMARY);

    /* (2) Υǡ (ԥåޥå ID) ׵ */
    XtGetSelectionValue(box, XA_PRIMARY, xa_figure, GetValueProc, NULL,
                        XtLastTimestampProcessed(XtDisplay(box)));

    /* (3) ȥʸ׵ */
    XtGetSelectionValue(box, XA_PRIMARY, xa_title, GetValueProc, NULL,
                        XtLastTimestampProcessed(XtDisplay(box)));

    /* (4) ׵ (MULTIPLE) νλ */
    XtSendSelectionRequest(box, XA_PRIMARY, 
                           XtLastTimestampProcessed(XtDisplay(box)));
}

/* ͭ: 쥯Υǡ׵ᤵ줿Ȥ˸ƤӽФ */
static Boolean ConvertProc(w, selection, target,
                           type_ret, val_ret, len_ret, format_ret)
    Widget w;
    Atom *selection;
    Atom *target;
    Atom *type_ret;
    XtPointer *val_ret;
    unsigned long *len_ret;
    int *format_ret;
{
    if (*selection != XA_PRIMARY)  /* Τ "PRIMARY" 쥯Τ */
        return False;

    /* ׵ᤵ줿åȤΥǡѰդ֤ */
    if (*target == xa_figure) {
        /* ׵ΥåȤ "_FIGURE" ʤ顤figure γž */
        /* figure 鳨 (ԥåޥå) Ф */
        XtVaGetValues(figure, XmNlabelPixmap, &pixmap, NULL);
        /* Υԥåޥå ID ž */
        *val_ret = &pixmap;
        *len_ret = 1;
        *type_ret = XA_PIXMAP;  /* פϥԥåޥå */
        *format_ret = 32;       /* ԥåޥåפΥեޥåȤ 32 */
        return True;   /* žǡνȤ */
    }
    else if (*target == xa_title) {
        /* ׵ΥåȤ "_TITLE" ʤ顤title ʸž */
        XmString string;
        char *text;
        /* title ٥ʸФ */
        XtVaGetValues(title, XmNlabelString, &string, NULL);
        /* ѥɡȥ󥰤̤ʸФ */
        XmStringGetLtoR(string, XmFONTLIST_DEFAULT_TAG, &text);
        XmStringFree(string);
        /* ʸž */
        *val_ret = text;
        *len_ret = strlen(text) + 1;  /* Ǹ NULL ɲ */
        *type_ret = XA_STRING;        /* ϱѸΥƥȤΤ߰ */
        *format_ret = 8;              /* ʸΥեޥåȤ 8 */
        return True;   /* žǡνȤ */
    }
    else
        return False;  /* Τʤ */
}

/* ׵: 쥯ΥǡäȤ˸ƤӽФ */
static void GetValueProc(w, client_data, selection, type, val, len, format)
    Widget w;
    XtPointer client_data;
    Atom *selection;
    Atom *type;
    XtPointer val;
    unsigned long *len;
    int *format;
{
    if (*len == 0 || val == NULL) { /* ǡμ˼ */
        XBell(XtDisplay(w), 0);  /* ٥ǼԤι */
        return;
    }

    if (*selection != XA_PRIMARY) { /* Τ "PRIMARY" 쥯Τ */
        XBell(XtDisplay(w), 0);  /* ٥ǼԤι */
        return;
    }

    /* äǡפ˹ä» */
    if (*type == XA_PIXMAP) {
        /* "PIXMAP" פʤ顤figure ˳ (ԥåޥå) ɽ */
        XtVaSetValues(figure, XmNlabelPixmap, *(Pixmap*)val, NULL);
    }
    else if (*type == XA_STRING) {
        /* "STRING" פʤ顤title ʸɽ */
        XmString string;
        string = XmStringCreateLocalized((char *)val);
        XtVaSetValues(title, XmNlabelString, string, NULL);
        XmStringFree(string);
    }
    else
        XBell(XtDisplay(w), 0);  /* פ㤦ȥ٥ǼԤι */

    XtFree((char *)val);
}
